#!/bin/sh

QT_VERSION="4"
#WORK_DIR=$(cd $(dirname $0); pwd)
WORK_DIR=/opt
USB_DIR=$1
LIB_BASE=$WORK_DIR/library/lib

# sys
export LD_LIBRARY_PATH=/usr/lib:$LD_LIBRARY_PATH

# base
export PATH=$WORK_DIR/software/sof:$PATH
export LD_LIBRARY_PATH=${LIB_BASE}:$LD_LIBRARY_PATH

# openssl
echo "export openssl"
export LIBOPENSSL_DIR=${LIB_BASE}/openssl
export LD_LIBRARY_PATH=${LIBOPENSSL_DIR}/lib:$LD_LIBRARY_PATH

#curl
echo "export curl"
export LIBCURL_DIR=${LIB_BASE}/libcurl
export LD_LIBRARY_PATH=${LIBCURL_DIR}/lib:$LD_LIBRARY_PATH

# libiconv
echo "export libiconv"
LIBICONV_DIR=${LIB_BASE}/libiconv
export LD_LIBRARY_PATH=${LIBICONV_DIR}/lib:$LD_LIBRARY_PATH
export LD_PRELOAD=${LIBICONV_DIR}/lib/preloadable_libiconv.so

# tslib
echo "export tslib"
export TSLIBDIR=${LIB_BASE}/tslib
export TSLIB_TSDEVICE=/dev/input/event0
export TSLIB_CONFFILE=${TSLIBDIR}/etc/ts.conf
export TSLIB_PLUGINDIR=${TSLIBDIR}/lib/ts
export TSLIB_CALIBFILE=/etc/pointercal
export TSLIB_CONSOLEDEVICE=none
export TSLIB_FBDEVICE=/dev/fb0
export LD_LIBRARY_PATH=${TSLIBDIR}/lib:$LD_LIBRARY_PATH

if [ -n "${USB_DIR}" ]; then
echo "-------USB part"
# 屏幕校准
        if [ -f ${USB_DIR}/lcd_cali ]; then
                echo "rm calibrate info file"
                rm -f $TSLIB_CALIBFILE
		echo "calibrate lcd"
		ts_calibrate
		sync
        fi
fi

if [ ! -f $TSLIB_CALIBFILE ]; then
		echo "calibrate lcd"
		ts_calibrate
		sync
fi

if [ $QT_VERSION = "5" ]; then
	# Qt5
	echo "Export Qt5"
	export QTDIR=${LIB_BASE}/qt5
	export QT_QPA_PLATFORM_PLUGIN_PATH=${QTDIR}/plugins
	export QWS_MOUSE_PROTO=tslib:/dev/input/event0
	export QT_QPA_FONTDIR=${QTDIR}/lib/fonts
	export QT_QPA_PLATFORM=linuxfb:fb=/dev/fb0:size=600x1024:mmSize=90x153:offset=0x0
	#export QT_AUTO_SCREEN_SCALE_FACTOR=1
	#export QT_SCALE_FACTOR=2
	export QT_QPA_GENERIC_PLUGINS=tslib
	export LD_LIBRARY_PATH=${QTDIR}/lib:$LD_LIBRARY_PATH
else
	# Qt4
	echo "export Qt4"
	export QTDIR=${LIB_BASE}/qt4
	export QT_PLUGIN_PATH=${QTDIR}/plugins
	export QWS_MOUSE_PROTO=tslib:/dev/input/event0
	export QWS_DISPLAY=LinuxFb:/dev/fb0
	export QT_QWS_FONTDIR=${LIB_BASE}/fonts
	export QT_QPA_PLATFORM=linuxfb:tty=/dev/fb0
	export LD_LIBRARY_PATH=${QTDIR}/lib:$LD_LIBRARY_PATH
	export QWS_SIZE=600x1024
fi
