#!﻿bin/ash

WORK_DIR=$(cd $(dirname $0); pwd)
SOFTWARE_DIR=${WORK_DIR}/software
QTAPP=${SOFTWARE_DIR}/sof/miniLCD
RUNPARA=" -qws RELEASE "

USB_DIR=$1
MAC_FILE=/etc/mac
MAC_ADDR='00:00:00:00:00:00'
LOG=/data/var/run.log

echo "" > $LOG
echo "WORK_DIR: ${WORK_DIR}"
echo "SOFTWARE_DIR:${SOFTWARE_DIR}"
echo "USB_DIR: ${USB_DIR}"

ISUPDATE=0
# find max dir
cd  ${SOFTWARE_DIR}
NEW_APP_DIR=`ls -vd [0-9].[0-9]*.[0-9]* | tail -n 1`
OLD_APP_DIR=`ls -vd [0-9].[0-9]*.[0-9]* | tail -n 2 | head  -n 1`
if [ -d ${SOFTWARE_DIR}/${NEW_APP_DIR} ] && \
   [ -d ${SOFTWARE_DIR}/${OLD_APP_DIR} ] && \
   [ ${SOFTWARE_DIR}/${OLD_APP_DIR} !=  ${SOFTWARE_DIR}/${NEW_APP_DIR} ]; then
    NEW_APP_DIR=${SOFTWARE_DIR}/${NEW_APP_DIR}
    OLD_APP_DIR=${SOFTWARE_DIR}/${OLD_APP_DIR}
    echo "NEW_APP_DIR:${NEW_APP_DIR}"
    echo "OLD_APP_DIR:${OLD_APP_DIR}"    
    ISUPDATE=1
else
    echo "miss OLD_APP_DIR"  >> $LOG
    # NEW_APP_DIR=" "
    NEW_APP_DIR=${SOFTWARE_DIR}/${NEW_APP_DIR}
    OLD_APP_DIR=" "
fi

# plug
if [ -e ${SOFTWARE_DIR}/sof/plug-in/plug-in.sh ]; then
    ${WORK_DIR}/software/sof/plug-in/plug-in.sh
    rm  -rf ${SOFTWARE_DIR}/sof/plug-in
fi


#NETWORK
# eth0
if [ -e ${MAC_FILE} ]; then
    MAC_ADDR=`cat ${MAC_FILE}`
fi

killall -9 udhcpc

echo "MAC:${MAC_ADDR}" >> $LOG
ifconfig eth0 hw ether "${MAC_ADDR}"
ifconfig eth0 up

# lo
ifconfig lo up 

# wlan0
echo "-------insmod 8188eu.ko"
insmod ${WORK_DIR}/kernel/ker/8188eu.ko
ifconfig wlan0 up

# #PWM
# echo "------insmod screenBacklightPWM.ko"
# insmod ${WORK_DIR}/kernel/ker/screenBacklightPWM.ko


#GPIO

#M0 reset
echo 113 >> /sys/class/gpio/export
echo out >> /sys/class/gpio/gpio113/direction
echo 0 >> /sys/class/gpio/gpio113/value
usleep 20000
echo 1 >> /sys/class/gpio/gpio113/value
echo 113 >> /sys/class/gpio/unexport

# RFID reset
# echo 115 >> /sys/class/gpio/export
# echo out >> /sys/class/gpio/gpio115/direction
# echo 0 >> /sys/class/gpio/gpio115/value
# usleep 20000
# echo 1 >> /sys/class/gpio/gpio115/value
# echo 115 >> /sys/class/gpio/unexport

#WiFI
echo 133 >> /sys/class/gpio/export            
echo out >> /sys/class/gpio/gpio133/direction    
echo 1 >> /sys/class/gpio/gpio133/value
 #power
echo 138 >> /sys/class/gpio/export            
echo out >> /sys/class/gpio/gpio138/direction    
echo 1 >> /sys/class/gpio/gpio138/value
usleep 200000
echo 0 >> /sys/class/gpio/gpio138/value

#debug
echo "1" > /proc/sys/kernel/core_uses_pid
echo "/data/var/core-%e-%p-%t" > /proc/sys/kernel/core_pattern

. ${SOFTWARE_DIR}/sof/load_env.sh ${USB_DIR} 


# OEM update
packages=`find ${USB_DIR}/OEM/ -name "*-software-*.tar.xz"`
echo "find packages:"
echo "${packages}"
if [ -n "${packages}" ]; then
    for package in $packages; do
        if [ -f ${package} ]; then
            echo "------load: ${package}"
            #get infomation
            package_name=${package##*/}
            part1=${package_name%-*}
            version=${part1##*-}
            rm -rf /opt/miniLCD/*
            mkdir -p /opt/miniLCD
            cp -f ${package} /opt/miniLCD/
            break
        fi
    done
    package=/opt/miniLCD/${package_name}
    echo "------update------"
    cat ${WORK_DIR}/image/update_start.bmp  >> /dev/fb0
    sleep 1
    echo "package=${package}"
    echo "version=${version}"
    mkdir -p ${SOFTWARE_DIR}/temp
    rm -f ${package%.*};sync
    unxz ${package}
    tar -xf ${package%.*}  -C ${SOFTWARE_DIR}/temp
    cd ${SOFTWARE_DIR}/temp
    md5sum -c md5sum.list
    ret=$?
    if [ 0 != $ret ] ;then
        echo "OEM software package md5 check failed"
        RUNPARA=" -qws RELEASE OEM_fail "
        rm ${SOFTWARE_DIR}/temp
    else
	echo "check success"
        rm -rf ${SOFTWARE_DIR}/sof
        rm -rf ${NEW_APP_DIR};sync
        mv ${SOFTWARE_DIR}/temp ${SOFTWARE_DIR}/${version};sync
        ln -sf ${SOFTWARE_DIR}/${version} ${SOFTWARE_DIR}/sof
	cat ${WORK_DIR}/image/update_end.bmp  >> /dev/fb0
	sleep 2
    fi
    sync
    halt -d 100
fi


umount ${USB_DIR}
rm -rf ${USB_DIR}

# running app
if [ -f ${QTAPP} ] ;then
    echo "***running app"
    chmod  777  ${QTAPP}
    ${QTAPP}${RUNPARA}&
    sleep 5;
fi


count=`ps -ef |grep ${QTAPP} |grep -v "grep" |wc -l`
if [ 0 == $count ] && [ 1 == $ISUPDATE ]; then
    echo ${QTAPP}"  not start ">>  $LOG
    rm -rf ${SOFTWARE_DIR}/sof
    rm -rf ${NEW_APP_DIR}
    ln -sf ${OLD_APP_DIR} ${SOFTWARE_DIR}/sof
    sync
    if [ -f ${QTAPP} ] ;then
        chmod  777  ${QTAPP}
        ${QTAPP} -qws RELEASE upgrade_fail &
    fi
else
    echo ${QTAPP}" start success" > $LOG
    if [ -d ${OLD_APP_DIR} ]; then
        echo "rm old app"
        rm -rf ${OLD_APP_DIR}
    fi
fi

